//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  Magenta
#property indicator_color3  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    MaPeriod        = 377;
extern int    MaPrice         = PRICE_CLOSE;
extern int    MaMethod        = 1;
extern double MaVerticalShift = 0;
extern int    MaShift         = 0;
extern bool   MultiColor      = true;

double ma[];
double maDa[];
double maDb[];
double slope[];

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0, ma);
   SetIndexBuffer(1, maDa);
   SetIndexBuffer(2, maDb);
   SetIndexBuffer(3, slope);
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         SetIndexShift(0,MaShift*timeFrame/Period());
         SetIndexShift(1,MaShift*timeFrame/Period());
         SetIndexShift(2,MaShift*timeFrame/Period());
return(0);
}
int deinit() { return (0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   double pipMultiplier = 1; 
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { ma[0] = limit+1; return(0); }
           if (Digits==3 || Digits==5) pipMultiplier = 10;
   //
   //
   //
   //
   //
   
    if (calculateValue || timeFrame==Period())
    {
       if (MultiColor && slope[limit]==-1) CleanPoint(limit,maDa,maDb);
       for (int i=limit; i>=0; i--)
       {
          ma[i]    = iMA(NULL,0,MaPeriod,0,MaMethod,MaPrice,i)+MaVerticalShift*pipMultiplier*Point;
          maDa[i]  = EMPTY_VALUE;
          maDb[i]  = EMPTY_VALUE;
          slope[i] = slope[i+1];
             if (ma[i]>ma[i+1]) slope[i] = 1;
             if (ma[i]<ma[i+1]) slope[i] =-1;
             if (MultiColor && slope[i] == -1) PlotPoint(i,maDa,maDb,ma);
       }
       
       return(0);
  }
  
  //
  //
  //
  //
  //
   
  limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
  if (MultiColor && slope[limit]==-1) CleanPoint(limit,maDa,maDb);
  for (i=limit; i>=0; i--)
  {   
     int y = iBarShift(NULL,timeFrame,Time[i]);
        ma[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaPrice,MaMethod,MaVerticalShift,MaShift,0,y);
        slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaPeriod,MaPrice,MaMethod,MaVerticalShift,MaShift,3,y); 
        maDa[i]  = EMPTY_VALUE; 
        maDb[i]  = EMPTY_VALUE;
        
        //
        //
        //
        //
        //
         
        if (y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

        //
        //
        //
        //
        //

        datetime time = iTime(NULL,timeFrame,y);
           for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
           for(int k = 1; k < n; k++) ma[i+k] = ma[i] + (ma[i+n] - ma[i])*k/n;
   }
   if (MultiColor) for (i=limit;i>=0;i--) if (slope[i] == -1) PlotPoint(i,maDa,maDb,ma);
return (0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}
  

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}